// -*- C++ -*-
// e391user.cc
//
// Fri Jul 26 16:27:36 JST 2002
// K.Sakashita
// 
// $Id: e391user.cc,v 1.1.1.1 2002/08/13 12:48:13 kensh Exp $
//
// $Log: e391user.cc,v $
// Revision 1.1.1.1  2002/08/13 12:48:13  kensh
//
//
// Start version.
//
//
//

#include <iostream>
#include <iomanip>
#include <list>
#include <string.h>
#include <stdio.h>
#include "TupleManager/TupleManager.h"
#include "ccfortran/ccfortran.h"
#include "unpack/AdcEvent.h"
#include "e391user.h"

// HBOOK
#define HLIM 1000000
int pawc_[HLIM];

typedef struct
{
  float EVTNO;
  float TRGBIT;
  float COSMIC01,COSMIC02,COSMIC03,COSMIC04,COSMIC05,COSMIC06;

} COSMICDATA;

COSMICDATA cosmicData;
static COSMICDATA cosmicData_clear;

static char* s_cosmicData =
"EVTNO TRGBIT COSMIC01 COSMIC02 COSMIC03 COSMIC04 COSMIC05 COSMIC06";

//
TupleManager ofile;
TMNtuple* ntCosmic;
//
int iEvent = 0;

// User Code
//
int user_init()
{

  std::cerr << "user_init()" << std::endl;

  // init ZEBRA
  TupleManager::init( HLIM );
  // output HBOOK file
  ofile.wopen( "sampleana.hbk", "OUT", 21 );
  ntCosmic = ofile.ntupleR( 100, "Cosmic", &cosmicData, s_cosmicData);

  return( 0 );
}

//
int user_begin_of_run( int RunNumber )
{

  std::cerr << "user_bor()" << std::endl;

  return( 0 );
}

//
int user_process_event( int RunNumber, int TrgBit, const AdcEvent& adc0 )
{

  //std::cerr << "user_main()" << std::endl;

  // initialize
  cosmicData = cosmicData_clear;

  int CosmicAdcCh[] = { 0, 1, 2, 3, 8, 9};
  float HighRangePed[] = { 523.8, 525.9, 535.4, 528.9, 531.0, 528.3};
  float LowRangePed[] = { 371.0, 363.0, 380.0, 349.5, 385.6, 376.0};
  float RawCharge[6];

  for( std::list<AdcModule>::const_iterator m=adc0.adcList().begin();
       m!=adc0.adcList().end(); m++ ){
    //
   if( m->pa() == 8 ){
      for( int i = 0; i < 6; i++){
	//
	RawCharge[i] = 0.0;
	//
        int RangeBit = (m->data( CosmicAdcCh[i] )&0xffff0000) >> 16;
        int RawAdc = (m->data( CosmicAdcCh[i] )&0x0000ffff);
        if( RangeBit == 1 ){ // High Range
          RawCharge[i] = 0.4*((float)RawAdc - HighRangePed[i]);
          
        }else{ // Low Range
          RawCharge[i] = 0.05*((float)RawAdc - LowRangePed[i]);
        }
      }
    }// if
  } 

  // fill ntuple
  cosmicData.EVTNO    = (float)iEvent;
  cosmicData.TRGBIT   = (float)TrgBit;
  cosmicData.COSMIC01 = RawCharge[0];
  cosmicData.COSMIC02 = RawCharge[1];
  cosmicData.COSMIC03 = RawCharge[2];
  cosmicData.COSMIC04 = RawCharge[3];
  cosmicData.COSMIC05 = RawCharge[4];
  cosmicData.COSMIC06 = RawCharge[5];
  ntCosmic->dump();

  iEvent++;

  return( 0 );
}

//
int user_end_of_run( int RunNumber )
{

  std::cerr << "user_eor()" << std::endl;

  return( 0 );
}

//
int user_term()
{
  std::cerr << "user_term()" << std::endl;

  ofile.close();

  return( 0 );
}
