// -*- C++ -*-
//
// user_inc.h
// 
//
// Author:  Ken Sakashita
// Created: Fri Nov 29 14:18:46 JST 2002
//
// $Id: user_inc.h,v 1.1 2002/11/29 05:49:07 kensh Exp $
//
// $Log: user_inc.h,v $
// Revision 1.1  2002/11/29 05:49:07  kensh
//
// Initial version
//
//
//

#ifndef USERINC_H_INCLUDED
#define USERINC_H_INCLUDED

//
// User defined Ntuple
typedef struct {
  int BaseHid;
  std::string Detname;
  int Xbin;
  float Xmin;
  float Xmax;
  int AdcCutL;
  int AdcCutH;
} HINFO;

#define N_DETECTOR 6
HINFO Hinfo[ N_DETECTOR] = { { 1000, "CsI", N_MAX_CSI, 0., N_MAX_CSI, 500, 600 },
			     { 2000, "CC03", N_MAX_CC03, 0., N_MAX_CC03, 500, 600 },
			     { 3000, "CV", N_MAX_CHARGEVETO, 0., N_MAX_CHARGEVETO, 500, 600 },
			     { 4000, "Sand", N_MAX_SANDWICH, 0., N_MAX_SANDWICH, 700, 700 },
			     { 5000, "BA", N_MAX_BEAMCATCHER, 0., N_MAX_BEAMCATCHER, 500, 600 },
			     { 6000, "C6", N_MAX_C6, 0., N_MAX_C6, 500, 600 } };
//
typedef struct {
  unsigned short Bit;
  std::string Name;

} TRGINFO;
#define N_TRIG 7
TRGINFO Trginfo[ N_TRIG ] = { { TRIG_CLOCK,    "Clock" },
			      { TRIG_COSMIC,   "Cosmic" },
			      { TRIG_XE,       "Xe" },
			      { TRIG_NCLUS,    "Nclus" },
			      { TRIG_NXCLUS,   "Nxclus" },
			      { TRIG_SPECIAL1, "Special1" },
			      { TRIG_SPECIAL2, "Special2" } };

//
#endif // USERINC_H_INCLUDED

