// -*- C++ -*-
//
// runControl.cc
//
// Author:  Mitsuhiro YAMAGA
// Created: Thu Oct 10 16:15:05 JST 2002
//
// $Id: runControl.cc,v 1.1 2002/10/10 16:40:18 yamaga Exp $
//
// Revision History
//
// $Log: runControl.cc,v $
// Revision 1.1  2002/10/10 16:40:18  yamaga
// new package
//
//
//

#include <iostream>
#include <list>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include "midas.h"

//
void  command_loop( char *host_name, char *exp_name );


////////
// usage
static void
usage( int argc, char* argv[] )
{
  std::cout << "usage : " << argv[0] << " [options]"
            << std::endl 
            << "  options:" << std::endl
            << "    -h <hostname>"
            << std::endl
            << "    -e <expname>"
            << std::endl;
}


////////
// main
int
main( int argc, char* argv[] )
{
  // command parser
  char  host_name[64] = "";
  char  exp_name[64]  = "";
  for( int i=1;i<argc;i++ ){
    if ( argv[i][0] == '-' ){
      if ( strcmp( argv[i],"-h" ) == 0 ){
        if ( ++i<argc && argv[i][0] != '-' ){
          strcpy( host_name,argv[i] );
        }
        else
          i--;
      }
      else if ( strcmp( argv[i],"-e" ) == 0 ){
        if ( ++i<argc && argv[i][0] != '-' ){
          strcpy( exp_name,argv[i] );
        }
        else
          i--;
      }
      else{
        std::cout << " unknown option : " << argv[i] << std::endl;
        usage( argc,argv );
        return( 1 );
      }
    }
    else{
      std::cout << " unknown option : " << argv[i] << std::endl;
      usage( argc,argv );
      return( 1 );
    }
  }
    
  // connect to experiment
  int  status = cm_connect_experiment1( host_name, exp_name,
                                        "runControl", NULL, 
                                        DEFAULT_ODB_SIZE,
                                        DEFAULT_WATCHDOG_TIMEOUT );
 
  if ( status != CM_SUCCESS )
    return( -1 );

  // disable watchdog
  cm_set_watchdog_params(TRUE, 0);

  // command loop
  command_loop( host_name, exp_name );
  
  // connect to experiment
  cm_disconnect_experiment();
  
  //
  return( 0 );
}

