// -*- C++ -*-
//
// ntuple.h
// NTUPLE information
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Fri Apr 20 15:44:51 JST 2001
//
// $Id: ntuple.h,v 1.1.1.1 2002/08/13 12:48:09 kensh Exp $
//
// Revision History
//
// $Log: ntuple.h,v $
// Revision 1.1.1.1  2002/08/13 12:48:09  kensh
//
//
// Start version.
//
//

#ifndef NTUPLE_H_INCLUDED
#define NTUPLE_H_INCLUDED

// Variable definition
// User must define GEN and NRESULT.

// 
#define  MAX_GEN 20
typedef struct{
  float XX,YY,ZZ,PX,PY,PZ,PP,EE;
  int   PN;
} GEN;
extern GEN gen; // ntuple.cc


// NRESULT : Output data
typedef struct{
  int    EVTNO,STATUS;
  int    NCBR,IDCBR[32];
  float  ESCI00[32];
  float  ESUS[32];
  float  ESCI[32];
  float  ELEAD[32];
  float  ES00SUM;
  float  ESUSSUM;
  float  ESCISUM;
  float  ELEADSUM;
  float  EOTHER;
  float  EESCAPE;
  float  ETOT;

  int    NGEN;
  float  XX[MAX_GEN],YY[MAX_GEN],ZZ[MAX_GEN];
  float  PX[MAX_GEN],PY[MAX_GEN],PZ[MAX_GEN],PP[MAX_GEN];
  float  PTH[MAX_GEN],PPH[MAX_GEN];
  float  EK[MAX_GEN],MASS[MAX_GEN];
  int    PN[MAX_GEN],MO[MAX_GEN],DA1[MAX_GEN],DA2[MAX_GEN];
  int    MECH[MAX_GEN],GSTATUS[MAX_GEN];

} NRESULT;
extern NRESULT nresult; // ntuple.cc
static NRESULT nresult_clear; // Zero components

static char  s_nresult[] = 
"EVTNO:I, STATUS:I, "
"NCBR:I::[0,32],  IDCBR(NCBR):I::[0,31], "
"ESCI00(NCBR):R, ESUS(NCBR):R, ESCI(NCBR):R, ELEAD(NCBR):R, "
"ES00SUM:R, ESUSSUM:R, ESCISUM:R, ELEADSUM:R, "
"EOTHER:R, EESCAPE:R, ETOT:R, "

"NGEN:I::[0,20], "
"XX(NGEN):R, YY(NGEN):R, ZZ(NGEN):R, "
"PX(NGEN):R, PY(NGEN):R, PZ(NGEN):R, PP(NGEN):R, "
"PTH(NGEN):R, PPH(NGEN):R, "
"EK(NGEN):R, MASS(NGEN):R, "
"PN(NGEN):I::[0,120], "
"MO(NGEN):I::[0,20], DA1(NGEN):I::[-1,20], DA2(NGEN):I::[-1,20], "
"MECH(NGEN):I, GSTATUS(NGEN):I";

#endif // NTUPLE_H_INCLUDED
