// -*- C++ -*-
//
// GsimFFread.cc
// Read Input-Card (gsim.dat)
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Thu Jul 12 15:12:46 JST 2001
//
// $Id: GsimFFread.cc,v 1.1.1.1 2002/08/13 12:48:09 kensh Exp $
//
// Revision History
//
// $Log: GsimFFread.cc,v $
// Revision 1.1.1.1  2002/08/13 12:48:09  kensh
//
//
// Start version.
//
//
#include <iostream>
#include "ccfortran/ccfortran.h"
#include "ccfortran/G321Common.h"
#include "gsim-general/GsimGeneral.h"

// gsim_ffread.F
extern "C" void  gsim_ffread_();


//////
void
GsimFFread()
{
  if ( gcflag_.ISWIT[3-1] > 0 )
    std::cerr << "GsimFFread" << std::endl; 

  //
  FFKEY( "D2BF", disp_2buf,     1, "INTEGER");
  FFKEY( "DZOM", disp_zoom,     2, "REAL");
  FFKEY( "DCEN", disp_center,   2, "REAL");
  FFKEY( "DRTH", disp_rotth,    1, "REAL");
  FFKEY( "DRPH", disp_rotph,    1, "REAL");
  FFKEY( "DRPS", disp_rotps,    1, "REAL");
  //
  FFKEY( "MNST", gctrak_.MAXNST,1, "INTEGER");
  //
  FFKEY( "TGTZ", TargetZ,       1, "REAL");
  
  // FFread
  gsim_ffread_();

}


