// -*- C++ -*-
//
// TMHistogram.h
// HBOOK accessing classes
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Tue Sep 11 17:17:42 JST 2001
//
// $Id: TMHistogram.h,v 1.1.1.1 2002/08/13 12:48:12 kensh Exp $
//
// Revision History
//
// $Log: TMHistogram.h,v $
// Revision 1.1.1.1  2002/08/13 12:48:12  kensh
//
//
// Start version.
//
//

#ifndef TMHISTOGRAM_H_INCLUDED
#define TMHISTOGRAM_H_INCLUDED

//
#include <string>


//
class TupleManager;


//////
class TMHistogram {
public:
  TMHistogram( const TupleManager* );
  ~TMHistogram();
  //
  void  book( int hid, const std::string& title,
              int xbin,double xmin, double xmax );
  void  book( int hid, const std::string& title,
              int xbin,double xmin, double xmax,
              int ybin,double ymin, double ymax );
  void  fill(  double x, double weight=1 );
  void  fill1( double x, double weight=1 ) { return fill(x,weight); }
  void  fill(  double x, double y, double weight );
  void  fill2( double x, double y, double weight=1 ){return fill(x,y,weight);}

private:
  //
  std::string  m_title;
  int          m_hid;
  int          m_xbin,m_ybin;
  double       m_xmin,m_xmax,m_ymin,m_ymax;
  const TupleManager* m_manager;
};


#endif // TMHISTOGRAM_H_INCLUDED

