/*                    Grand Unified IO service routine

		      guexpandpath


      This routine understand the header of the path name
      in order to switch multiple protocols by looking at the protocol field
      which start with / and end with : placed at the head of
      the file name.   Currently supported protocols are
      FS(file system) and HPSS(high performance storage system).

      /hpss:<hpss name>  -> invoke hpss calls for the file <hpss name>
      /:                 -> expanded to /.../cc.kek.jp/fs
                                           (hard wired for the momtne)
                            and use the system standard stat call.
      anything else      -> use the system standard stat call.

*/	 

static char rcsid_guexpandpath[] = "@(#) $Id: guexpandpath.c,v 1.1 2002/12/11 14:12:33 yamaga Exp $";

#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
#include <unistd.h>
#include "hpss_api.h"
#include "hpss_types.h"
#include "u_signed64.h"
#include "gufio/hpss_bufapi.h"
#include "gufio/gufio.h"


int guexpandpath(const char *filename, char *localpath)
{
  int fd, hfd;
  int status;
  char *tmpstr;

  char header[] = "/hpss:";
  char cell[] = "/.../cc.kek.jp/fs";

  if ( strncasecmp(filename,header,6) == 0 ) {
    memmove((void*)localpath,
	    (void*)(filename+strlen(header)*sizeof(char)),
	    (size_t)((strlen(filename)-strlen(header)+1)*sizeof(char))
	    );
    return(GUFILE_HPSS);
  } else if ( strncasecmp(filename,"/:",2) == 0 ) {
    tmpstr = (char *)malloc((strlen(filename)+1)*sizeof(char));
    strncpy(tmpstr,cell,17);
    strncpy(tmpstr+17,(char *)filename+2,strlen(filename)+1);
    strncpy(localpath,tmpstr,strlen(tmpstr)+1);
    return(GUFILE_FS);
  } else {
    memmove((void*)localpath,
	    (void*)filename,
	    (size_t)((strlen(filename)+1)*sizeof(char))
	    );
    return(GUFILE_FS);
  }

  return(-1);
}
