/* -*- C -*- 

   gureopenall.c
   workaround for suspended job on HPSS file
   Thu Jun 28 10:38:31 JST 2001
   M.Yamaga (yamaga@post.kek.jp)

   $Log: gureopenall.c,v $
   Revision 1.1  2002/12/11 14:12:33  yamaga
   Imported package.


*/	 

static char rcsid_gureopenall[] = "@(#) $Id: gureopenall.c,v 1.1 2002/12/11 14:12:33 yamaga Exp $";

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include "gufio/hpss_bufapi.h"
#include "gufio/gufio.h"

#define DBG 0

int
gureopenall( void )
{
  int   nfd;
  int*  hfdlist;
  int*  newhfdlist;
  struct gufio_tbl  *tbl;
  int  rc;

  if (DBG) printf( "s - gureopenall\n" );

  /* search HPSS file */
  if ( ( tbl = gutblfirst() ) != NULL ){
    nfd = 0;
    do{
      if ( tbl->ftype == GUFILE_HPSS )
        nfd++;
    } while( tbl = gutblnext( tbl ) );
    if (DBG) printf( "    nfd=%d\n",nfd );

    if ( nfd > 0 ){
      hfdlist = (int*)malloc( nfd * sizeof(int) );
      if ( hfdlist == NULL ){
        free( hfdlist );
        perror( "gureopenall : malloc hfdlst" );
        return( -1 );
      }
      newhfdlist = (int*)malloc( nfd * sizeof(int) );
      if ( newhfdlist == NULL ){
        free( newhfdlist );
        perror( "gureopenall : malloc newhfdlst" );
        return( -1 );
      }

      /* hfdlist */
      tbl = gutblfirst();
      nfd = 0;
      do{
        if ( tbl->ftype == GUFILE_HPSS ){
          hfdlist[nfd++] = tbl->hfd;
        }
      } while( tbl = gutblnext( tbl ) );

      /* reopen */
      do {
        rc = hpss_BufreopenAll( nfd,hfdlist,newhfdlist );
      } while( rc != nfd );

      /* remap */
      tbl = gutblfirst();
      nfd = 0;
      do{
        if ( tbl->ftype == GUFILE_HPSS ){
          if ( tbl->hfd == hfdlist[nfd] ){
            tbl->hfd = newhfdlist[nfd];
            if (DBG) printf( "    remap hfd %d -> %d\n",
                             hfdlist[nfd],newhfdlist[nfd] );
            nfd++;
          }
          else{
            if (DBG) printf( "    cannot remap hfd %d\n",hfdlist[nfd] );
          }
        }
      } while( tbl = gutblnext( tbl ) );

      /* free */
      free( newhfdlist );
      free( hfdlist );
    }
  }

  return( nfd );
}

