// -*- C++ -*-
//
// MTdcEvent.h
//
// Sun Dec  1 13:03:09 JST 2002
// Mitsuhiro YAMAGA
//
// $Id: MTdcEvent.h,v 1.1 2002/12/01 14:34:51 yamaga Exp $
//
// $Log: MTdcEvent.h,v $
// Revision 1.1  2002/12/01 14:34:51  yamaga
// Initial version for multihit TDC.
//
//
//

#ifndef MTDCEVENT_H_INCLDUED
#define MTDCEVENT_H_INCLDUED

//
#include <list>
#include "midas.h"
#include "MTdcModule.h"


//
class MTdcEvent {
public:
  // constructor
  MTdcEvent();
  MTdcEvent( int crate, const EVENT_HEADER* pheader, const DWORD* pdata,
             int banksize, int nth_event=-1 );
  ~MTdcEvent();
  // extractor
  const EVENT_HEADER&  eventHeader() const { return m_eventHeader; }
  int           serial() const { return m_serial; }
  int           crate()  const { return m_crate;  }
  unsigned int  flag()   const { return m_flag;   }
  bool          valid()  const { return m_valid;  }
  const std::list<MTdcModule>&  tdcList() const { return m_tdcList; }
  const MTdcModule&             tdc( int pa ) const;
  int           nhitChannel() const;
  int           nhit() const;
  //
  int     unpack( int crate, const EVENT_HEADER* pheader, const DWORD* pdata,
                  int banksize, int nth_event=-1 );
  void    setCrate( int crate ) { m_crate = crate; }
  void    setValid( bool valid ) { m_valid = valid; }

private:
  // data
  EVENT_HEADER  m_eventHeader;
  int           m_serial;
  int           m_crate;
  unsigned int  m_flag;
  bool          m_valid;
  std::list<MTdcModule>     m_tdcList;
  //
};


// inline


#endif // MTDCEVENT_H_INCLDUED
