// -*- C++ -*-
//
// TdcEvent.h
//
// Mon Jul 15 09:00:04 JST 2002
// Mitsuhiro YAMAGA
//
// $Id: TdcEvent.h,v 1.1.1.1 2002/08/13 12:48:12 kensh Exp $
//
// $Log: TdcEvent.h,v $
// Revision 1.1.1.1  2002/08/13 12:48:12  kensh
//
//
// Start version.
//
//

#ifndef TDCEVENT_H_INCLDUED
#define TDCEVENT_H_INCLDUED

//
#include <list>
#include "midas.h"
#include "TdcModule.h"


//
class TdcEvent {
public:
  // constructor
  TdcEvent();
  TdcEvent( int crate, const EVENT_HEADER* pheader, const DWORD* pdata,
            int banksize, int nth_event=-1 );
  ~TdcEvent();
  // extractor
  const EVENT_HEADER&  eventHeader() const { return m_eventHeader; }
  int     serial() const { return m_serial; }
  int     crate()  const { return m_crate; }
  unsigned int  flag() const { return m_flag; }
  bool    valid() const { return m_valid; }
  const std::list<TdcModule>&  tdcList() const { return m_tdcList; }
  const std::list<unsigned int>&  smp() const { return m_smp; }
  // 
  const TdcModule&  tdc( int sa ) const;
  int     nhit() const;
  //
  int     unpack( int crate, const EVENT_HEADER* pheader, const DWORD* pdata,
                  int banksize, int nth_event=-1 );
  void    setCrate( int crate ) { m_crate = crate; }
  void    setValid( bool valid ) { m_valid = valid; }
  int     smp( const DWORD* pdata, int banksize );
  int     smp( const std::list<unsigned int>& s );

private:
  // data
  EVENT_HEADER  m_eventHeader;
  int           m_serial;
  int           m_crate;
  unsigned int  m_flag;
  bool          m_valid;
  std::list<TdcModule>     m_tdcList;
  std::list<unsigned int>  m_smp;
  //
};


// inline


#endif // TDCEVENT_H_INCLDUED
